import es
import gamethread
import threading
from time import strftime
from usermsg import hudhint

class Commands(object):
    def __init__(self):
        self.tick         = 0
        self.currentMap   = es.ServerVar('eventscripts_currentmap')
        self.friendlyFire = es.ServerVar('mp_friendlyfire')
        es.addons.registerTickListener(self.tickListener)
        gamethread.delayed(1, es.addons.unregisterTickListener, self.tickListener)
    def tickListener(self):
        self.tick += 1
    def getNextMap(self):
        o = open(es.getString('eventscripts_gamedir') + '/mapcycle.txt')
        f = o.read().split('\n')
        o.close()
        index = 0
        while f[index] != str(self.currentMap):
            index += 1
        if len(f) >= index + 1:
            index += 1
        else:
            index = 0
        return f[index]
    def getCurrentMap(self):
        return str(self.currentMap)
    def getTickRate(self):
        if self.tick > 25 and self.tick < 50:
            self.tick = 33
        elif self.tick > 50 and self.tick < 75:
            self.tick = 66
        elif self.tick > 75:
            self.tick = 100
        return str(self.tick)
    def getFF(self):
        return str(self.friendlyFire).replace('1', 'on').replace('0', 'off')
    def getCurrentTime(self):
        return strftime('%H:%M - %d.%m.%y')
commands = Commands()

class Adverts(object):
    def __init__(self):
        self.currentLength = 0
        self.currentName   = ''
        self.adverts       = {'#chat':[], '#top':[], '#hudhint':[], '#center':[]}
        o = open(es.getAddonPath('bad') + '/bad_adverts.txt')
        f = o.read().split('\n')
        o.close()
        ads = []
        for x in f:
            if str(x) and not x.startswith('//'):
                ads.append(x)
        for x in ads:
            x = x.split(': ')
            text = ''
            for y in x[1:]:
                text += ': %s' % y
            text = text[2:]
            for what in self.adverts:
                if x[0] == what:
                    self.adverts[what].append(text)
    def startNew(self, what):
        self.cancelDelayed()
        if what == 'chat':
            thread = threading.Thread(target=self.chatAdvert)
        elif what == 'top':
            thread = threading.Thread(target=self.topAdvert)
        elif what == 'hudhint':
            thread = threading.Thread(target=self.hudhintAdvert)
        elif what == 'center':
            thread = threading.Thread(target=self.centerAdvert)
        thread.start()
    def replaceInfoTokens(self, x):
        x = x.replace('#default ', '#default')
        x = x.replace('#yellow ', '#default')
        x = x.replace('#green ', '#green')
        x = x.replace('#lightgreen', '#lightgreen')
        x = x.replace('#nextmap', commands.getNextMap())
        x = x.replace('#currentmap ', commands.getCurrentMap())
        x = x.replace('#tickrate', commands.getTickRate())
        x = x.replace('#ff', commands.getFF())
        x = x.replace('#thetime', commands.getCurrentTime())
        return x
    def listWrapper(self, what):
        adList = []
        ads    = self.adverts[what]
        for x in ads:
            adList.append(self.replaceInfoTokens(x))
        if self.currentLength < len(ads):
            what = what.replace('#', '')
            self.currentName = 'bad_advert_' + what
            gamethread.delayedname(120, self.currentName, self.startNew, what)
            ad = adList[self.currentLength]
            self.currentLength += 1
            return ad
        self.currentLength = 0
        return False
    def chatAdvert(self):
        advert = self.listWrapper('#chat')
        if advert:
            es.msg('#multi', advert)
        else:
            self.startNew('top')
    def topAdvert(self):
        advert = self.listWrapper('#top')
        if advert:
            color = '#' + advert.split('#')[1]
            ad = advert.replace(color, '')
            for userid in es.getUseridList():
                es.toptext(userid, 5, color, ad)
        else:
            self.startNew('hudhint')
    def hudhintAdvert(self):
        advert = self.listWrapper('#hudhint')
        if advert:
            for userid in es.getUseridList():
                hudhint(userid, advert)
        else:
            self.startNew('center')
    def centerAdvert(self):
        advert = self.listWrapper('#center')
        if advert:
            es.centermsg(advert)
        else:
            self.startNew('chat')
    def startAdverts(self, restart=False):
        self.cancelDelayed()
        if restart:
            gamethread.delayed(2, self.startNew, 'chat')
    def cancelDelayed(self):
        if str(self.currentName):
            gamethread.cancelDelayed(self.currentName)
adverts = Adverts()

def es_map_start(ev):
    adverts.startAdverts(True)

def load():
    es.ServerVar('bad_ver', 1.0, "Adverts played ingame (like Mani's, but more configurable).").makepublic()
    adverts.startAdverts(True)

def unload():
    adverts.startAdverts()